chrome.runtime.onInstalled.addListener(() => {
    chrome.storage.local.set({ isRecording: false, apiKey: '', assistantId: '', threadId: '' });
  });
  
  chrome.runtime.onMessage.addListener((request, sender, sendResponse) => {
    console.log("Background script received a message:", request);
    if (request.action === "startSpeechToText" || request.action === "stopSpeechToText") {
      chrome.tabs.query({ active: true, currentWindow: true }, (tabs) => {
        if (tabs.length > 0) {
          console.log("Active tab found:", tabs[0].id, tabs[0]);
          chrome.scripting.executeScript(
            {
              target: { tabId: tabs[0].id },
              files: ['content.js']
            },
            () => {
              if (chrome.runtime.lastError) {
                console.error("Script injection failed:", chrome.runtime.lastError.message);
              } else {
                console.log("Script injected successfully");
                chrome.tabs.sendMessage(tabs[0].id, request);
              }
            }
          );
        } else {
          console.error("No active tab found");
        }
      });
    } else if (request.action === "updateBadge") {
      chrome.action.setBadgeText({ text: request.text });
      chrome.action.setBadgeBackgroundColor({ color: "red" });
    } else if (request.action === "updateThreadId") {
      chrome.storage.local.set({ threadId: request.threadId });
    }
  });
  
  chrome.commands.onCommand.addListener((command) => {
    if (command === "toggle-recording") {
      chrome.storage.local.get(['isRecording', 'apiKey', 'assistantId', 'threadId'], (data) => {
        const { isRecording, apiKey, assistantId, threadId } = data;
        if (isRecording) {
          console.log("Sending stop message to content script.");
          chrome.runtime.sendMessage({ action: "stopSpeechToText" });
          chrome.storage.local.set({ isRecording: false });
          chrome.runtime.sendMessage({ action: "updateBadge", text: "" });
        } else {
          console.log("Sending start message to content script.");
          chrome.runtime.sendMessage({ action: "startSpeechToText", apiKey, assistantId, threadId });
          chrome.storage.local.set({ isRecording: true });
          chrome.runtime.sendMessage({ action: "updateBadge", text: "REC" });
        }
      });
    }
  });
  